/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { GeneratedPdfCommand } from '../models';
/**
 * AzureFunctionsAppWebhooksApi - axios parameter creator
 * @export
 */
export declare const AzureFunctionsAppWebhooksApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Webhook for Pdf generation azure functions app
     * @param {GeneratedPdfCommand} [generatedPdfCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AzurefunctionsappwebhooksPdfgeneratedPost: (generatedPdfCommand?: GeneratedPdfCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * AzureFunctionsAppWebhooksApi - functional programming interface
 * @export
 */
export declare const AzureFunctionsAppWebhooksApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Webhook for Pdf generation azure functions app
     * @param {GeneratedPdfCommand} [generatedPdfCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AzurefunctionsappwebhooksPdfgeneratedPost(generatedPdfCommand?: GeneratedPdfCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
};
/**
 * AzureFunctionsAppWebhooksApi - factory interface
 * @export
 */
export declare const AzureFunctionsAppWebhooksApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Webhook for Pdf generation azure functions app
     * @param {GeneratedPdfCommand} [generatedPdfCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AzurefunctionsappwebhooksPdfgeneratedPost(generatedPdfCommand?: GeneratedPdfCommand, options?: any): AxiosPromise<boolean>;
};
/**
 * Request parameters for apiV1AzurefunctionsappwebhooksPdfgeneratedPost operation in AzureFunctionsAppWebhooksApi.
 * @export
 * @interface AzureFunctionsAppWebhooksApiApiV1AzurefunctionsappwebhooksPdfgeneratedPostRequest
 */
export interface AzureFunctionsAppWebhooksApiApiV1AzurefunctionsappwebhooksPdfgeneratedPostRequest {
    /**
     *
     * @type {GeneratedPdfCommand}
     * @memberof AzureFunctionsAppWebhooksApiApiV1AzurefunctionsappwebhooksPdfgeneratedPost
     */
    readonly generatedPdfCommand?: GeneratedPdfCommand;
}
/**
 * AzureFunctionsAppWebhooksApi - object-oriented interface
 * @export
 * @class AzureFunctionsAppWebhooksApi
 * @extends {BaseAPI}
 */
export declare class AzureFunctionsAppWebhooksApi extends BaseAPI {
    /**
     *
     * @summary Webhook for Pdf generation azure functions app
     * @param {AzureFunctionsAppWebhooksApiApiV1AzurefunctionsappwebhooksPdfgeneratedPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AzureFunctionsAppWebhooksApi
     */
    apiV1AzurefunctionsappwebhooksPdfgeneratedPost(requestParameters?: AzureFunctionsAppWebhooksApiApiV1AzurefunctionsappwebhooksPdfgeneratedPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
}
//# sourceMappingURL=azure-functions-app-webhooks-api.d.ts.map