/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { TranslationContentsModel } from '../models';
import { TranslationTargetEntities } from '../models';
import { UpdateContentTextOnlyValueDomains } from '../models';
/**
 * DevSupportsApi - axios parameter creator
 * @export
 */
export declare const DevSupportsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Apply database migration (Auth policies: RequireAdministratorRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsApplydatabasemigrationPost: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Generate missing favicons for all webapps (Auth policies: RequireAdministratorRole)
     * @param {Array<string>} [webAppIds]
     * @param {boolean} [dryRun]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsGeneratemissingfaviconsPost: (webAppIds?: Array<string>, dryRun?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Find missing translated content, translate all found contents (Auth policies: RequireAdministratorRole)
     * @param {TranslationTargetEntities} targetEntity
     * @param {string} basisLanguageCode
     * @param {Array<string>} [translateToFields] Set name of fields to translate; All fields try translate if list is null or empty.
     * @param {string} [id]
     * @param {boolean} [includesAllEntries] Represents whether only to proceed target items that need to be translated. If true, translate also items that have already been translated. (Default: false)
     * @param {boolean} [isDryRun] Default: true
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsTranslatePost: (targetEntity: TranslationTargetEntities, basisLanguageCode: string, translateToFields?: Array<string>, id?: string, includesAllEntries?: boolean, isDryRun?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update contentTextOnly values (Auth policies: RequireAdministratorRole)
     * @param {Array<UpdateContentTextOnlyValueDomains>} [targetDomains]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsUpdatecontenttextonlyvaluesPost: (targetDomains?: Array<UpdateContentTextOnlyValueDomains>, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * DevSupportsApi - functional programming interface
 * @export
 */
export declare const DevSupportsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Apply database migration (Auth policies: RequireAdministratorRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsApplydatabasemigrationPost(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>>;
    /**
     *
     * @summary Generate missing favicons for all webapps (Auth policies: RequireAdministratorRole)
     * @param {Array<string>} [webAppIds]
     * @param {boolean} [dryRun]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsGeneratemissingfaviconsPost(webAppIds?: Array<string>, dryRun?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>>;
    /**
     *
     * @summary Find missing translated content, translate all found contents (Auth policies: RequireAdministratorRole)
     * @param {TranslationTargetEntities} targetEntity
     * @param {string} basisLanguageCode
     * @param {Array<string>} [translateToFields] Set name of fields to translate; All fields try translate if list is null or empty.
     * @param {string} [id]
     * @param {boolean} [includesAllEntries] Represents whether only to proceed target items that need to be translated. If true, translate also items that have already been translated. (Default: false)
     * @param {boolean} [isDryRun] Default: true
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsTranslatePost(targetEntity: TranslationTargetEntities, basisLanguageCode: string, translateToFields?: Array<string>, id?: string, includesAllEntries?: boolean, isDryRun?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TranslationContentsModel>>;
    /**
     *
     * @summary Update contentTextOnly values (Auth policies: RequireAdministratorRole)
     * @param {Array<UpdateContentTextOnlyValueDomains>} [targetDomains]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsUpdatecontenttextonlyvaluesPost(targetDomains?: Array<UpdateContentTextOnlyValueDomains>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>>;
};
/**
 * DevSupportsApi - factory interface
 * @export
 */
export declare const DevSupportsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Apply database migration (Auth policies: RequireAdministratorRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsApplydatabasemigrationPost(options?: any): AxiosPromise<string>;
    /**
     *
     * @summary Generate missing favicons for all webapps (Auth policies: RequireAdministratorRole)
     * @param {Array<string>} [webAppIds]
     * @param {boolean} [dryRun]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsGeneratemissingfaviconsPost(webAppIds?: Array<string>, dryRun?: boolean, options?: any): AxiosPromise<string>;
    /**
     *
     * @summary Find missing translated content, translate all found contents (Auth policies: RequireAdministratorRole)
     * @param {TranslationTargetEntities} targetEntity
     * @param {string} basisLanguageCode
     * @param {Array<string>} [translateToFields] Set name of fields to translate; All fields try translate if list is null or empty.
     * @param {string} [id]
     * @param {boolean} [includesAllEntries] Represents whether only to proceed target items that need to be translated. If true, translate also items that have already been translated. (Default: false)
     * @param {boolean} [isDryRun] Default: true
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsTranslatePost(targetEntity: TranslationTargetEntities, basisLanguageCode: string, translateToFields?: Array<string>, id?: string, includesAllEntries?: boolean, isDryRun?: boolean, options?: any): AxiosPromise<TranslationContentsModel>;
    /**
     *
     * @summary Update contentTextOnly values (Auth policies: RequireAdministratorRole)
     * @param {Array<UpdateContentTextOnlyValueDomains>} [targetDomains]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DevsupportsUpdatecontenttextonlyvaluesPost(targetDomains?: Array<UpdateContentTextOnlyValueDomains>, options?: any): AxiosPromise<string>;
};
/**
 * Request parameters for apiV1DevsupportsGeneratemissingfaviconsPost operation in DevSupportsApi.
 * @export
 * @interface DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPostRequest
 */
export interface DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPostRequest {
    /**
     *
     * @type {Array<string>}
     * @memberof DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPost
     */
    readonly webAppIds?: Array<string>;
    /**
     *
     * @type {boolean}
     * @memberof DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPost
     */
    readonly dryRun?: boolean;
}
/**
 * Request parameters for apiV1DevsupportsTranslatePost operation in DevSupportsApi.
 * @export
 * @interface DevSupportsApiApiV1DevsupportsTranslatePostRequest
 */
export interface DevSupportsApiApiV1DevsupportsTranslatePostRequest {
    /**
     *
     * @type {TranslationTargetEntities}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly targetEntity: TranslationTargetEntities;
    /**
     *
     * @type {string}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly basisLanguageCode: string;
    /**
     * Set name of fields to translate; All fields try translate if list is null or empty.
     * @type {Array<string>}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly translateToFields?: Array<string>;
    /**
     *
     * @type {string}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly id?: string;
    /**
     * Represents whether only to proceed target items that need to be translated. If true, translate also items that have already been translated. (Default: false)
     * @type {boolean}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly includesAllEntries?: boolean;
    /**
     * Default: true
     * @type {boolean}
     * @memberof DevSupportsApiApiV1DevsupportsTranslatePost
     */
    readonly isDryRun?: boolean;
}
/**
 * Request parameters for apiV1DevsupportsUpdatecontenttextonlyvaluesPost operation in DevSupportsApi.
 * @export
 * @interface DevSupportsApiApiV1DevsupportsUpdatecontenttextonlyvaluesPostRequest
 */
export interface DevSupportsApiApiV1DevsupportsUpdatecontenttextonlyvaluesPostRequest {
    /**
     *
     * @type {Array<UpdateContentTextOnlyValueDomains>}
     * @memberof DevSupportsApiApiV1DevsupportsUpdatecontenttextonlyvaluesPost
     */
    readonly targetDomains?: Array<UpdateContentTextOnlyValueDomains>;
}
/**
 * DevSupportsApi - object-oriented interface
 * @export
 * @class DevSupportsApi
 * @extends {BaseAPI}
 */
export declare class DevSupportsApi extends BaseAPI {
    /**
     *
     * @summary Apply database migration (Auth policies: RequireAdministratorRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DevSupportsApi
     */
    apiV1DevsupportsApplydatabasemigrationPost(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string, any>>;
    /**
     *
     * @summary Generate missing favicons for all webapps (Auth policies: RequireAdministratorRole)
     * @param {DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DevSupportsApi
     */
    apiV1DevsupportsGeneratemissingfaviconsPost(requestParameters?: DevSupportsApiApiV1DevsupportsGeneratemissingfaviconsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string, any>>;
    /**
     *
     * @summary Find missing translated content, translate all found contents (Auth policies: RequireAdministratorRole)
     * @param {DevSupportsApiApiV1DevsupportsTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DevSupportsApi
     */
    apiV1DevsupportsTranslatePost(requestParameters: DevSupportsApiApiV1DevsupportsTranslatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<TranslationContentsModel, any>>;
    /**
     *
     * @summary Update contentTextOnly values (Auth policies: RequireAdministratorRole)
     * @param {DevSupportsApiApiV1DevsupportsUpdatecontenttextonlyvaluesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DevSupportsApi
     */
    apiV1DevsupportsUpdatecontenttextonlyvaluesPost(requestParameters?: DevSupportsApiApiV1DevsupportsUpdatecontenttextonlyvaluesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string, any>>;
}
//# sourceMappingURL=dev-supports-api.d.ts.map