/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateTemplateVersionCommand } from '../models';
import { SendTemplateVersionCommand } from '../models';
import { TemplateVersionModel } from '../models';
import { TemplateVersionsModel } from '../models';
import { UpdateTemplateVersionCommand } from '../models';
/**
 * EmailMarketingsApi - axios parameter creator
 * @export
 */
export declare const EmailMarketingsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all templateVersions. (Auth policies: RequireManagerRole)
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsGet: (page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a templateVersion. (Auth policies: RequireManagerRole)
     * @param {CreateTemplateVersionCommand} [createTemplateVersionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsPost: (createTemplateVersionCommand?: CreateTemplateVersionCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete templateVersion. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdDelete: (versionId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get templateVersion. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdGet: (versionId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update templateVersion. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {UpdateTemplateVersionCommand} [updateTemplateVersionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdPut: (versionId: string, updateTemplateVersionCommand?: UpdateTemplateVersionCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Send templateVersion email. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {SendTemplateVersionCommand} [sendTemplateVersionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdSendPost: (versionId: string, sendTemplateVersionCommand?: SendTemplateVersionCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * EmailMarketingsApi - functional programming interface
 * @export
 */
export declare const EmailMarketingsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all templateVersions. (Auth policies: RequireManagerRole)
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsGet(page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TemplateVersionsModel>>;
    /**
     *
     * @summary Create a templateVersion. (Auth policies: RequireManagerRole)
     * @param {CreateTemplateVersionCommand} [createTemplateVersionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsPost(createTemplateVersionCommand?: CreateTemplateVersionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TemplateVersionModel>>;
    /**
     *
     * @summary Delete templateVersion. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdDelete(versionId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get templateVersion. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdGet(versionId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TemplateVersionModel>>;
    /**
     *
     * @summary Update templateVersion. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {UpdateTemplateVersionCommand} [updateTemplateVersionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdPut(versionId: string, updateTemplateVersionCommand?: UpdateTemplateVersionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TemplateVersionModel>>;
    /**
     *
     * @summary Send templateVersion email. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {SendTemplateVersionCommand} [sendTemplateVersionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdSendPost(versionId: string, sendTemplateVersionCommand?: SendTemplateVersionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
};
/**
 * EmailMarketingsApi - factory interface
 * @export
 */
export declare const EmailMarketingsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all templateVersions. (Auth policies: RequireManagerRole)
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsGet(page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<TemplateVersionsModel>;
    /**
     *
     * @summary Create a templateVersion. (Auth policies: RequireManagerRole)
     * @param {CreateTemplateVersionCommand} [createTemplateVersionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsPost(createTemplateVersionCommand?: CreateTemplateVersionCommand, options?: any): AxiosPromise<TemplateVersionModel>;
    /**
     *
     * @summary Delete templateVersion. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdDelete(versionId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get templateVersion. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdGet(versionId: string, options?: any): AxiosPromise<TemplateVersionModel>;
    /**
     *
     * @summary Update templateVersion. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {UpdateTemplateVersionCommand} [updateTemplateVersionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdPut(versionId: string, updateTemplateVersionCommand?: UpdateTemplateVersionCommand, options?: any): AxiosPromise<TemplateVersionModel>;
    /**
     *
     * @summary Send templateVersion email. (Auth policies: RequireManagerRole)
     * @param {string} versionId
     * @param {SendTemplateVersionCommand} [sendTemplateVersionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailmarketingsVersionsVersionIdSendPost(versionId: string, sendTemplateVersionCommand?: SendTemplateVersionCommand, options?: any): AxiosPromise<boolean>;
};
/**
 * Request parameters for apiV1EmailmarketingsVersionsGet operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsGetRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsGetRequest {
    /**
     *
     * @type {number}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1EmailmarketingsVersionsPost operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsPostRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsPostRequest {
    /**
     *
     * @type {CreateTemplateVersionCommand}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsPost
     */
    readonly createTemplateVersionCommand?: CreateTemplateVersionCommand;
}
/**
 * Request parameters for apiV1EmailmarketingsVersionsVersionIdDelete operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdDeleteRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdDelete
     */
    readonly versionId: string;
}
/**
 * Request parameters for apiV1EmailmarketingsVersionsVersionIdGet operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdGetRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdGet
     */
    readonly versionId: string;
}
/**
 * Request parameters for apiV1EmailmarketingsVersionsVersionIdPut operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPutRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPut
     */
    readonly versionId: string;
    /**
     *
     * @type {UpdateTemplateVersionCommand}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPut
     */
    readonly updateTemplateVersionCommand?: UpdateTemplateVersionCommand;
}
/**
 * Request parameters for apiV1EmailmarketingsVersionsVersionIdSendPost operation in EmailMarketingsApi.
 * @export
 * @interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPostRequest
 */
export interface EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPostRequest {
    /**
     *
     * @type {string}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPost
     */
    readonly versionId: string;
    /**
     *
     * @type {SendTemplateVersionCommand}
     * @memberof EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPost
     */
    readonly sendTemplateVersionCommand?: SendTemplateVersionCommand;
}
/**
 * EmailMarketingsApi - object-oriented interface
 * @export
 * @class EmailMarketingsApi
 * @extends {BaseAPI}
 */
export declare class EmailMarketingsApi extends BaseAPI {
    /**
     *
     * @summary Get all templateVersions. (Auth policies: RequireManagerRole)
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    apiV1EmailmarketingsVersionsGet(requestParameters?: EmailMarketingsApiApiV1EmailmarketingsVersionsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<TemplateVersionsModel, any>>;
    /**
     *
     * @summary Create a templateVersion. (Auth policies: RequireManagerRole)
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    apiV1EmailmarketingsVersionsPost(requestParameters?: EmailMarketingsApiApiV1EmailmarketingsVersionsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<TemplateVersionModel, any>>;
    /**
     *
     * @summary Delete templateVersion. (Auth policies: RequireManagerRole)
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    apiV1EmailmarketingsVersionsVersionIdDelete(requestParameters: EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get templateVersion. (Auth policies: RequireManagerRole)
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    apiV1EmailmarketingsVersionsVersionIdGet(requestParameters: EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<TemplateVersionModel, any>>;
    /**
     *
     * @summary Update templateVersion. (Auth policies: RequireManagerRole)
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    apiV1EmailmarketingsVersionsVersionIdPut(requestParameters: EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<TemplateVersionModel, any>>;
    /**
     *
     * @summary Send templateVersion email. (Auth policies: RequireManagerRole)
     * @param {EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailMarketingsApi
     */
    apiV1EmailmarketingsVersionsVersionIdSendPost(requestParameters: EmailMarketingsApiApiV1EmailmarketingsVersionsVersionIdSendPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
}
//# sourceMappingURL=email-marketings-api.d.ts.map