/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateFaqCategoryCommand } from '../models';
import { FaqCategoriesModel } from '../models';
import { FaqCategoryModel } from '../models';
import { UpdateFaqCategoryCommand } from '../models';
/**
 * FaqCategoriesApi - axios parameter creator
 * @export
 */
export declare const FaqCategoriesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {boolean} [forceDelete]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdDelete: (faqCategoryId: string, forceDelete?: boolean, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdGet: (faqCategoryId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {UpdateFaqCategoryCommand} [updateFaqCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdPut: (faqCategoryId: string, updateFaqCategoryCommand?: UpdateFaqCategoryCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Revalidate faqCategory (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdRevalidatePost: (faqCategoryId: string, includeCurrent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all FaqCategories. (Auth policies: RequireLocalManagerRole)
     * @param {string} [id]
     * @param {string} [parentId]
     * @param {string} [name]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesGet: (id?: string, parentId?: string, name?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {CreateFaqCategoryCommand} [createFaqCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesPost: (createFaqCategoryCommand?: CreateFaqCategoryCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get FaqCategory by slug. (Auth policies: RequireLocalManagerRole)
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesSlugGet: (slug: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * FaqCategoriesApi - functional programming interface
 * @export
 */
export declare const FaqCategoriesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {boolean} [forceDelete]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdDelete(faqCategoryId: string, forceDelete?: boolean, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdGet(faqCategoryId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqCategoryModel>>;
    /**
     *
     * @summary Update FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {UpdateFaqCategoryCommand} [updateFaqCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdPut(faqCategoryId: string, updateFaqCategoryCommand?: UpdateFaqCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqCategoryModel>>;
    /**
     *
     * @summary Revalidate faqCategory (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdRevalidatePost(faqCategoryId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get all FaqCategories. (Auth policies: RequireLocalManagerRole)
     * @param {string} [id]
     * @param {string} [parentId]
     * @param {string} [name]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesGet(id?: string, parentId?: string, name?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqCategoriesModel>>;
    /**
     *
     * @summary Create a FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {CreateFaqCategoryCommand} [createFaqCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesPost(createFaqCategoryCommand?: CreateFaqCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqCategoryModel>>;
    /**
     *
     * @summary Get FaqCategory by slug. (Auth policies: RequireLocalManagerRole)
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesSlugGet(slug: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqCategoryModel>>;
};
/**
 * FaqCategoriesApi - factory interface
 * @export
 */
export declare const FaqCategoriesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {boolean} [forceDelete]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdDelete(faqCategoryId: string, forceDelete?: boolean, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdGet(faqCategoryId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<FaqCategoryModel>;
    /**
     *
     * @summary Update FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {UpdateFaqCategoryCommand} [updateFaqCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdPut(faqCategoryId: string, updateFaqCategoryCommand?: UpdateFaqCategoryCommand, options?: any): AxiosPromise<FaqCategoryModel>;
    /**
     *
     * @summary Revalidate faqCategory (Auth policies: RequireLocalManagerRole)
     * @param {string} faqCategoryId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesFaqCategoryIdRevalidatePost(faqCategoryId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get all FaqCategories. (Auth policies: RequireLocalManagerRole)
     * @param {string} [id]
     * @param {string} [parentId]
     * @param {string} [name]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesGet(id?: string, parentId?: string, name?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FaqCategoriesModel>;
    /**
     *
     * @summary Create a FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {CreateFaqCategoryCommand} [createFaqCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesPost(createFaqCategoryCommand?: CreateFaqCategoryCommand, options?: any): AxiosPromise<FaqCategoryModel>;
    /**
     *
     * @summary Get FaqCategory by slug. (Auth policies: RequireLocalManagerRole)
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqcategoriesSlugGet(slug: string, languageCode?: string, options?: any): AxiosPromise<FaqCategoryModel>;
};
/**
 * Request parameters for apiV1FaqcategoriesFaqCategoryIdDelete operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDeleteRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDelete
     */
    readonly faqCategoryId: string;
    /**
     *
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDelete
     */
    readonly forceDelete?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1FaqcategoriesFaqCategoryIdGet operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGetRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGet
     */
    readonly faqCategoryId: string;
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * Request parameters for apiV1FaqcategoriesFaqCategoryIdPut operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPutRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPut
     */
    readonly faqCategoryId: string;
    /**
     *
     * @type {UpdateFaqCategoryCommand}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPut
     */
    readonly updateFaqCategoryCommand?: UpdateFaqCategoryCommand;
}
/**
 * Request parameters for apiV1FaqcategoriesFaqCategoryIdRevalidatePost operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePostRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePostRequest {
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePost
     */
    readonly faqCategoryId: string;
    /**
     *
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePost
     */
    readonly includeCurrent?: boolean;
}
/**
 * Request parameters for apiV1FaqcategoriesGet operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesGetRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesGetRequest {
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly parentId?: string;
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly hospitalName?: string;
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly returnDefaultValue?: boolean;
    /**
     *
     * @type {number}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1FaqcategoriesPost operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesPostRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesPostRequest {
    /**
     *
     * @type {CreateFaqCategoryCommand}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesPost
     */
    readonly createFaqCategoryCommand?: CreateFaqCategoryCommand;
}
/**
 * Request parameters for apiV1FaqcategoriesSlugGet operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesSlugGetRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesSlugGetRequest {
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesSlugGet
     */
    readonly slug: string;
    /**
     *
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesSlugGet
     */
    readonly languageCode?: string;
}
/**
 * FaqCategoriesApi - object-oriented interface
 * @export
 * @class FaqCategoriesApi
 * @extends {BaseAPI}
 */
export declare class FaqCategoriesApi extends BaseAPI {
    /**
     *
     * @summary Delete FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    apiV1FaqcategoriesFaqCategoryIdDelete(requestParameters: FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    apiV1FaqcategoriesFaqCategoryIdGet(requestParameters: FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqCategoryModel, any>>;
    /**
     *
     * @summary Update FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    apiV1FaqcategoriesFaqCategoryIdPut(requestParameters: FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqCategoryModel, any>>;
    /**
     *
     * @summary Revalidate faqCategory (Auth policies: RequireLocalManagerRole)
     * @param {FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    apiV1FaqcategoriesFaqCategoryIdRevalidatePost(requestParameters: FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get all FaqCategories. (Auth policies: RequireLocalManagerRole)
     * @param {FaqCategoriesApiApiV1FaqcategoriesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    apiV1FaqcategoriesGet(requestParameters?: FaqCategoriesApiApiV1FaqcategoriesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqCategoriesModel, any>>;
    /**
     *
     * @summary Create a FaqCategory. (Auth policies: RequireLocalManagerRole)
     * @param {FaqCategoriesApiApiV1FaqcategoriesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    apiV1FaqcategoriesPost(requestParameters?: FaqCategoriesApiApiV1FaqcategoriesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqCategoryModel, any>>;
    /**
     *
     * @summary Get FaqCategory by slug. (Auth policies: RequireLocalManagerRole)
     * @param {FaqCategoriesApiApiV1FaqcategoriesSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    apiV1FaqcategoriesSlugGet(requestParameters: FaqCategoriesApiApiV1FaqcategoriesSlugGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqCategoryModel, any>>;
}
//# sourceMappingURL=faq-categories-api.d.ts.map