/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreatePromotionCommand } from '../models';
import { PromotionModel } from '../models';
import { PromotionType } from '../models';
import { PromotionsModel } from '../models';
import { UpdatePromotionCommand } from '../models';
/**
 * PromotionsApi - axios parameter creator
 * @export
 */
export declare const PromotionsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get promotions (Auth policies: RequireDoctorRole)
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {PromotionType} [promotionType]
     * @param {boolean} [showHidden]
     * @param {boolean} [isActivated]
     * @param {Date} [start]
     * @param {Date} [end]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsGet: (languageCode?: string, hospitalId?: string, promotionType?: PromotionType, showHidden?: boolean, isActivated?: boolean, start?: Date, end?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create promotion (Auth policies: RequireDoctorRole)
     * @param {CreatePromotionCommand} [createPromotionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPost: (createPromotionCommand?: CreatePromotionCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdDelete: (promotionId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdGet: (promotionId: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {UpdatePromotionCommand} [updatePromotionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdPut: (promotionId: string, updatePromotionCommand?: UpdatePromotionCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdReactivatePut: (promotionId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * PromotionsApi - functional programming interface
 * @export
 */
export declare const PromotionsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get promotions (Auth policies: RequireDoctorRole)
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {PromotionType} [promotionType]
     * @param {boolean} [showHidden]
     * @param {boolean} [isActivated]
     * @param {Date} [start]
     * @param {Date} [end]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsGet(languageCode?: string, hospitalId?: string, promotionType?: PromotionType, showHidden?: boolean, isActivated?: boolean, start?: Date, end?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PromotionsModel>>;
    /**
     *
     * @summary Create promotion (Auth policies: RequireDoctorRole)
     * @param {CreatePromotionCommand} [createPromotionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPost(createPromotionCommand?: CreatePromotionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PromotionModel>>;
    /**
     *
     * @summary Delete promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdDelete(promotionId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdGet(promotionId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PromotionModel>>;
    /**
     *
     * @summary Update promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {UpdatePromotionCommand} [updatePromotionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdPut(promotionId: string, updatePromotionCommand?: UpdatePromotionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PromotionModel>>;
    /**
     *
     * @summary Reactivate promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdReactivatePut(promotionId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
};
/**
 * PromotionsApi - factory interface
 * @export
 */
export declare const PromotionsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get promotions (Auth policies: RequireDoctorRole)
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {PromotionType} [promotionType]
     * @param {boolean} [showHidden]
     * @param {boolean} [isActivated]
     * @param {Date} [start]
     * @param {Date} [end]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsGet(languageCode?: string, hospitalId?: string, promotionType?: PromotionType, showHidden?: boolean, isActivated?: boolean, start?: Date, end?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<PromotionsModel>;
    /**
     *
     * @summary Create promotion (Auth policies: RequireDoctorRole)
     * @param {CreatePromotionCommand} [createPromotionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPost(createPromotionCommand?: CreatePromotionCommand, options?: any): AxiosPromise<PromotionModel>;
    /**
     *
     * @summary Delete promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdDelete(promotionId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdGet(promotionId: string, languageCode?: string, options?: any): AxiosPromise<PromotionModel>;
    /**
     *
     * @summary Update promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {UpdatePromotionCommand} [updatePromotionCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdPut(promotionId: string, updatePromotionCommand?: UpdatePromotionCommand, options?: any): AxiosPromise<PromotionModel>;
    /**
     *
     * @summary Reactivate promotion (Auth policies: RequireDoctorRole)
     * @param {string} promotionId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PromotionsPromotionIdReactivatePut(promotionId: string, options?: any): AxiosPromise<boolean>;
};
/**
 * Request parameters for apiV1PromotionsGet operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsGetRequest
 */
export interface PromotionsApiApiV1PromotionsGetRequest {
    /**
     *
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {PromotionType}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly promotionType?: PromotionType;
    /**
     *
     * @type {boolean}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly isActivated?: boolean;
    /**
     *
     * @type {Date}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly start?: Date;
    /**
     *
     * @type {Date}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly end?: Date;
    /**
     *
     * @type {number}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1PromotionsPost operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsPostRequest
 */
export interface PromotionsApiApiV1PromotionsPostRequest {
    /**
     *
     * @type {CreatePromotionCommand}
     * @memberof PromotionsApiApiV1PromotionsPost
     */
    readonly createPromotionCommand?: CreatePromotionCommand;
}
/**
 * Request parameters for apiV1PromotionsPromotionIdDelete operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsPromotionIdDeleteRequest
 */
export interface PromotionsApiApiV1PromotionsPromotionIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdDelete
     */
    readonly promotionId: string;
    /**
     *
     * @type {boolean}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1PromotionsPromotionIdGet operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsPromotionIdGetRequest
 */
export interface PromotionsApiApiV1PromotionsPromotionIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdGet
     */
    readonly promotionId: string;
    /**
     *
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1PromotionsPromotionIdPut operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsPromotionIdPutRequest
 */
export interface PromotionsApiApiV1PromotionsPromotionIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdPut
     */
    readonly promotionId: string;
    /**
     *
     * @type {UpdatePromotionCommand}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdPut
     */
    readonly updatePromotionCommand?: UpdatePromotionCommand;
}
/**
 * Request parameters for apiV1PromotionsPromotionIdReactivatePut operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsPromotionIdReactivatePutRequest
 */
export interface PromotionsApiApiV1PromotionsPromotionIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdReactivatePut
     */
    readonly promotionId: string;
}
/**
 * PromotionsApi - object-oriented interface
 * @export
 * @class PromotionsApi
 * @extends {BaseAPI}
 */
export declare class PromotionsApi extends BaseAPI {
    /**
     *
     * @summary Get promotions (Auth policies: RequireDoctorRole)
     * @param {PromotionsApiApiV1PromotionsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    apiV1PromotionsGet(requestParameters?: PromotionsApiApiV1PromotionsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PromotionsModel, any>>;
    /**
     *
     * @summary Create promotion (Auth policies: RequireDoctorRole)
     * @param {PromotionsApiApiV1PromotionsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    apiV1PromotionsPost(requestParameters?: PromotionsApiApiV1PromotionsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PromotionModel, any>>;
    /**
     *
     * @summary Delete promotion (Auth policies: RequireDoctorRole)
     * @param {PromotionsApiApiV1PromotionsPromotionIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    apiV1PromotionsPromotionIdDelete(requestParameters: PromotionsApiApiV1PromotionsPromotionIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get promotion (Auth policies: RequireDoctorRole)
     * @param {PromotionsApiApiV1PromotionsPromotionIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    apiV1PromotionsPromotionIdGet(requestParameters: PromotionsApiApiV1PromotionsPromotionIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PromotionModel, any>>;
    /**
     *
     * @summary Update promotion (Auth policies: RequireDoctorRole)
     * @param {PromotionsApiApiV1PromotionsPromotionIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    apiV1PromotionsPromotionIdPut(requestParameters: PromotionsApiApiV1PromotionsPromotionIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PromotionModel, any>>;
    /**
     *
     * @summary Reactivate promotion (Auth policies: RequireDoctorRole)
     * @param {PromotionsApiApiV1PromotionsPromotionIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    apiV1PromotionsPromotionIdReactivatePut(requestParameters: PromotionsApiApiV1PromotionsPromotionIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
}
//# sourceMappingURL=promotions-api.d.ts.map