/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { HospitalServiceModel } from '../models';
import { HospitalServicesModel } from '../models';
import { MarketingType } from '../models';
import { Procedure } from '../models';
/**
 * ServicesApi - axios parameter creator
 * @export
 */
export declare const ServicesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all HospitalServices. (Auth policies: RequireLocalManagerRole)
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [slug]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [hospitalSlug]
     * @param {string} [specialtyId]
     * @param {string} [specialtyName]
     * @param {string} [specialtyTypeId]
     * @param {string} [specialtyTypeName]
     * @param {string} [serviceCategoryId]
     * @param {MarketingType} [marketingType]
     * @param {Procedure} [procedure]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicesGet: (id?: string, name?: string, slug?: string, hospitalId?: string, hospitalName?: string, hospitalSlug?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceCategoryId?: string, marketingType?: MarketingType, procedure?: Procedure, created?: Date, showHidden?: boolean, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get Service by ServiceId (Auth policies: RequireLocalManagerRole)
     * @param {string} serviceId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicesServiceIdGet: (serviceId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get Service by slug (Auth policies: RequireLocalManagerRole)
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicesSlugGet: (slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * ServicesApi - functional programming interface
 * @export
 */
export declare const ServicesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all HospitalServices. (Auth policies: RequireLocalManagerRole)
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [slug]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [hospitalSlug]
     * @param {string} [specialtyId]
     * @param {string} [specialtyName]
     * @param {string} [specialtyTypeId]
     * @param {string} [specialtyTypeName]
     * @param {string} [serviceCategoryId]
     * @param {MarketingType} [marketingType]
     * @param {Procedure} [procedure]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicesGet(id?: string, name?: string, slug?: string, hospitalId?: string, hospitalName?: string, hospitalSlug?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceCategoryId?: string, marketingType?: MarketingType, procedure?: Procedure, created?: Date, showHidden?: boolean, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalServicesModel>>;
    /**
     *
     * @summary Get Service by ServiceId (Auth policies: RequireLocalManagerRole)
     * @param {string} serviceId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicesServiceIdGet(serviceId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalServiceModel>>;
    /**
     *
     * @summary Get Service by slug (Auth policies: RequireLocalManagerRole)
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalServiceModel>>;
};
/**
 * ServicesApi - factory interface
 * @export
 */
export declare const ServicesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all HospitalServices. (Auth policies: RequireLocalManagerRole)
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [slug]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [hospitalSlug]
     * @param {string} [specialtyId]
     * @param {string} [specialtyName]
     * @param {string} [specialtyTypeId]
     * @param {string} [specialtyTypeName]
     * @param {string} [serviceCategoryId]
     * @param {MarketingType} [marketingType]
     * @param {Procedure} [procedure]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicesGet(id?: string, name?: string, slug?: string, hospitalId?: string, hospitalName?: string, hospitalSlug?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceCategoryId?: string, marketingType?: MarketingType, procedure?: Procedure, created?: Date, showHidden?: boolean, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<HospitalServicesModel>;
    /**
     *
     * @summary Get Service by ServiceId (Auth policies: RequireLocalManagerRole)
     * @param {string} serviceId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicesServiceIdGet(serviceId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<HospitalServiceModel>;
    /**
     *
     * @summary Get Service by slug (Auth policies: RequireLocalManagerRole)
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicesSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<HospitalServiceModel>;
};
/**
 * Request parameters for apiV1ServicesGet operation in ServicesApi.
 * @export
 * @interface ServicesApiApiV1ServicesGetRequest
 */
export interface ServicesApiApiV1ServicesGetRequest {
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly slug?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly hospitalName?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly hospitalSlug?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly specialtyId?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly specialtyName?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly specialtyTypeId?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly specialtyTypeName?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly serviceCategoryId?: string;
    /**
     *
     * @type {MarketingType}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly marketingType?: MarketingType;
    /**
     *
     * @type {Procedure}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly procedure?: Procedure;
    /**
     *
     * @type {Date}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly created?: Date;
    /**
     *
     * @type {boolean}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {number}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof ServicesApiApiV1ServicesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1ServicesServiceIdGet operation in ServicesApi.
 * @export
 * @interface ServicesApiApiV1ServicesServiceIdGetRequest
 */
export interface ServicesApiApiV1ServicesServiceIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesServiceIdGet
     */
    readonly serviceId: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesServiceIdGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof ServicesApiApiV1ServicesServiceIdGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * Request parameters for apiV1ServicesSlugGet operation in ServicesApi.
 * @export
 * @interface ServicesApiApiV1ServicesSlugGetRequest
 */
export interface ServicesApiApiV1ServicesSlugGetRequest {
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesSlugGet
     */
    readonly slug: string;
    /**
     *
     * @type {string}
     * @memberof ServicesApiApiV1ServicesSlugGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof ServicesApiApiV1ServicesSlugGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * ServicesApi - object-oriented interface
 * @export
 * @class ServicesApi
 * @extends {BaseAPI}
 */
export declare class ServicesApi extends BaseAPI {
    /**
     *
     * @summary Get all HospitalServices. (Auth policies: RequireLocalManagerRole)
     * @param {ServicesApiApiV1ServicesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesApi
     */
    apiV1ServicesGet(requestParameters?: ServicesApiApiV1ServicesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalServicesModel, any>>;
    /**
     *
     * @summary Get Service by ServiceId (Auth policies: RequireLocalManagerRole)
     * @param {ServicesApiApiV1ServicesServiceIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesApi
     */
    apiV1ServicesServiceIdGet(requestParameters: ServicesApiApiV1ServicesServiceIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalServiceModel, any>>;
    /**
     *
     * @summary Get Service by slug (Auth policies: RequireLocalManagerRole)
     * @param {ServicesApiApiV1ServicesSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesApi
     */
    apiV1ServicesSlugGet(requestParameters: ServicesApiApiV1ServicesSlugGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalServiceModel, any>>;
}
//# sourceMappingURL=services-api.d.ts.map