/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateWhatsAppTemplateMediaCommand } from '../models';
import { DeleteWhatsAppTemplateMediaByTagCommand } from '../models';
import { MetaMediaType } from '../models';
import { WhatsAppTemplateMediaModel } from '../models';
import { WhatsAppTemplateMediasModel } from '../models';
/**
 * WhatsAppTemplateMediaApi - axios parameter creator
 * @export
 */
export declare const WhatsAppTemplateMediaApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Retrieves a paginated list of all WhatsApp template media (Auth policies: RequireLocalManagerRole)
     * @param {string} [id]
     * @param {string} [templateId]
     * @param {MetaMediaType} [metaMediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaGet: (id?: string, templateId?: string, metaMediaType?: MetaMediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Deletes a specific WhatsApp template media by its ID (Auth policies: RequireLocalManagerRole)
     * @param {string} id The unique identifier of the template media to delete
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaIdDelete: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Retrieves a specific WhatsApp template media by its ID (Auth policies: RequireLocalManagerRole)
     * @param {string} id The unique identifier of the template media
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaIdGet: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Creates a new WhatsApp template media (Auth policies: RequireLocalManagerRole)
     * @param {CreateWhatsAppTemplateMediaCommand} [createWhatsAppTemplateMediaCommand] The command containing template media creation details
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaPost: (createWhatsAppTemplateMediaCommand?: CreateWhatsAppTemplateMediaCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Deletes WhatsApp template media by matching tag key and value (Auth policies: RequireLocalManagerRole)
     * @param {DeleteWhatsAppTemplateMediaByTagCommand} [deleteWhatsAppTemplateMediaByTagCommand] The command containing tag key and value to match for deletion
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaTagsDelete: (deleteWhatsAppTemplateMediaByTagCommand?: DeleteWhatsAppTemplateMediaByTagCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * WhatsAppTemplateMediaApi - functional programming interface
 * @export
 */
export declare const WhatsAppTemplateMediaApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Retrieves a paginated list of all WhatsApp template media (Auth policies: RequireLocalManagerRole)
     * @param {string} [id]
     * @param {string} [templateId]
     * @param {MetaMediaType} [metaMediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaGet(id?: string, templateId?: string, metaMediaType?: MetaMediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WhatsAppTemplateMediasModel>>;
    /**
     *
     * @summary Deletes a specific WhatsApp template media by its ID (Auth policies: RequireLocalManagerRole)
     * @param {string} id The unique identifier of the template media to delete
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaIdDelete(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Retrieves a specific WhatsApp template media by its ID (Auth policies: RequireLocalManagerRole)
     * @param {string} id The unique identifier of the template media
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaIdGet(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WhatsAppTemplateMediaModel>>;
    /**
     *
     * @summary Creates a new WhatsApp template media (Auth policies: RequireLocalManagerRole)
     * @param {CreateWhatsAppTemplateMediaCommand} [createWhatsAppTemplateMediaCommand] The command containing template media creation details
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaPost(createWhatsAppTemplateMediaCommand?: CreateWhatsAppTemplateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WhatsAppTemplateMediaModel>>;
    /**
     *
     * @summary Deletes WhatsApp template media by matching tag key and value (Auth policies: RequireLocalManagerRole)
     * @param {DeleteWhatsAppTemplateMediaByTagCommand} [deleteWhatsAppTemplateMediaByTagCommand] The command containing tag key and value to match for deletion
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaTagsDelete(deleteWhatsAppTemplateMediaByTagCommand?: DeleteWhatsAppTemplateMediaByTagCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
};
/**
 * WhatsAppTemplateMediaApi - factory interface
 * @export
 */
export declare const WhatsAppTemplateMediaApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Retrieves a paginated list of all WhatsApp template media (Auth policies: RequireLocalManagerRole)
     * @param {string} [id]
     * @param {string} [templateId]
     * @param {MetaMediaType} [metaMediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaGet(id?: string, templateId?: string, metaMediaType?: MetaMediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<WhatsAppTemplateMediasModel>;
    /**
     *
     * @summary Deletes a specific WhatsApp template media by its ID (Auth policies: RequireLocalManagerRole)
     * @param {string} id The unique identifier of the template media to delete
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaIdDelete(id: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Retrieves a specific WhatsApp template media by its ID (Auth policies: RequireLocalManagerRole)
     * @param {string} id The unique identifier of the template media
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaIdGet(id: string, options?: any): AxiosPromise<WhatsAppTemplateMediaModel>;
    /**
     *
     * @summary Creates a new WhatsApp template media (Auth policies: RequireLocalManagerRole)
     * @param {CreateWhatsAppTemplateMediaCommand} [createWhatsAppTemplateMediaCommand] The command containing template media creation details
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaPost(createWhatsAppTemplateMediaCommand?: CreateWhatsAppTemplateMediaCommand, options?: any): AxiosPromise<WhatsAppTemplateMediaModel>;
    /**
     *
     * @summary Deletes WhatsApp template media by matching tag key and value (Auth policies: RequireLocalManagerRole)
     * @param {DeleteWhatsAppTemplateMediaByTagCommand} [deleteWhatsAppTemplateMediaByTagCommand] The command containing tag key and value to match for deletion
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WhatsapptemplatemediaTagsDelete(deleteWhatsAppTemplateMediaByTagCommand?: DeleteWhatsAppTemplateMediaByTagCommand, options?: any): AxiosPromise<boolean>;
};
/**
 * Request parameters for apiV1WhatsapptemplatemediaGet operation in WhatsAppTemplateMediaApi.
 * @export
 * @interface WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaGetRequest
 */
export interface WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaGetRequest {
    /**
     *
     * @type {string}
     * @memberof WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaGet
     */
    readonly templateId?: string;
    /**
     *
     * @type {MetaMediaType}
     * @memberof WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaGet
     */
    readonly metaMediaType?: MetaMediaType;
    /**
     *
     * @type {number}
     * @memberof WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1WhatsapptemplatemediaIdDelete operation in WhatsAppTemplateMediaApi.
 * @export
 * @interface WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaIdDeleteRequest
 */
export interface WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaIdDeleteRequest {
    /**
     * The unique identifier of the template media to delete
     * @type {string}
     * @memberof WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaIdDelete
     */
    readonly id: string;
}
/**
 * Request parameters for apiV1WhatsapptemplatemediaIdGet operation in WhatsAppTemplateMediaApi.
 * @export
 * @interface WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaIdGetRequest
 */
export interface WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaIdGetRequest {
    /**
     * The unique identifier of the template media
     * @type {string}
     * @memberof WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaIdGet
     */
    readonly id: string;
}
/**
 * Request parameters for apiV1WhatsapptemplatemediaPost operation in WhatsAppTemplateMediaApi.
 * @export
 * @interface WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaPostRequest
 */
export interface WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaPostRequest {
    /**
     * The command containing template media creation details
     * @type {CreateWhatsAppTemplateMediaCommand}
     * @memberof WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaPost
     */
    readonly createWhatsAppTemplateMediaCommand?: CreateWhatsAppTemplateMediaCommand;
}
/**
 * Request parameters for apiV1WhatsapptemplatemediaTagsDelete operation in WhatsAppTemplateMediaApi.
 * @export
 * @interface WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaTagsDeleteRequest
 */
export interface WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaTagsDeleteRequest {
    /**
     * The command containing tag key and value to match for deletion
     * @type {DeleteWhatsAppTemplateMediaByTagCommand}
     * @memberof WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaTagsDelete
     */
    readonly deleteWhatsAppTemplateMediaByTagCommand?: DeleteWhatsAppTemplateMediaByTagCommand;
}
/**
 * WhatsAppTemplateMediaApi - object-oriented interface
 * @export
 * @class WhatsAppTemplateMediaApi
 * @extends {BaseAPI}
 */
export declare class WhatsAppTemplateMediaApi extends BaseAPI {
    /**
     *
     * @summary Retrieves a paginated list of all WhatsApp template media (Auth policies: RequireLocalManagerRole)
     * @param {WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WhatsAppTemplateMediaApi
     */
    apiV1WhatsapptemplatemediaGet(requestParameters?: WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<WhatsAppTemplateMediasModel, any>>;
    /**
     *
     * @summary Deletes a specific WhatsApp template media by its ID (Auth policies: RequireLocalManagerRole)
     * @param {WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WhatsAppTemplateMediaApi
     */
    apiV1WhatsapptemplatemediaIdDelete(requestParameters: WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Retrieves a specific WhatsApp template media by its ID (Auth policies: RequireLocalManagerRole)
     * @param {WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WhatsAppTemplateMediaApi
     */
    apiV1WhatsapptemplatemediaIdGet(requestParameters: WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<WhatsAppTemplateMediaModel, any>>;
    /**
     *
     * @summary Creates a new WhatsApp template media (Auth policies: RequireLocalManagerRole)
     * @param {WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WhatsAppTemplateMediaApi
     */
    apiV1WhatsapptemplatemediaPost(requestParameters?: WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<WhatsAppTemplateMediaModel, any>>;
    /**
     *
     * @summary Deletes WhatsApp template media by matching tag key and value (Auth policies: RequireLocalManagerRole)
     * @param {WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaTagsDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WhatsAppTemplateMediaApi
     */
    apiV1WhatsapptemplatemediaTagsDelete(requestParameters?: WhatsAppTemplateMediaApiApiV1WhatsapptemplatemediaTagsDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
}
//# sourceMappingURL=whats-app-template-media-api.d.ts.map